#include <bits/stdc++.h>
using namespace std;
void Main(){
int n,m;
cin >>n>>m;
vector <long long> a(n);
vector <long long> b(m);
for(int i=0;i<n;i++)cin >>a[i];
for(int j=0;j<m;j++)cin >>b[j];
sort(a.begin(),a.end());
long long diff= a[1]-a[0];
for(int i=1;i<n;i++){
diff=__gcd(diff,a[i]-a[i-1]);
}
long long mod=a[0]%diff;
int rez=1;
for(int i=0;i<n;i++)if((a[i]%diff)!=mod)rez=0;
for(int i=0;i<m;i++)if(b[i]%diff==mod)rez=0;
cout <<rez<<endl;
}
int main(){
ios_base::sync_with_stdio(false);
cin.tie(0);
cout.tie(0);
int t;
cin >>t;
for(int i=0;i<t;i++)Main();
}